"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runGlobal = void 0;
const react_native_navigation_1 = require("react-native-navigation");
const NavSource_1 = require("./NavSource");
function runGlobal(main, engine) {
    const sources = Object.assign(Object.assign({}, engine.sources), { navigation: new NavSource_1.NavSource() });
    const sinks = main(sources);
    engine.run(sinks);
    if (sinks.navigation) {
        let latestId;
        react_native_navigation_1.Navigation.events().registerComponentDidAppearListener(({ componentId }) => {
            latestId = componentId;
        });
        sinks.navigation.subscribe({
            next: (cmd) => {
                var _a;
                if (cmd.type === 'setRoot') {
                    react_native_navigation_1.Navigation.setRoot(cmd.layout);
                    return;
                }
                const id = (_a = cmd.id) !== null && _a !== void 0 ? _a : latestId;
                if (!id) {
                    console.error('The global screen component cannot apply a ' +
                        'navigation command if an "id" is not provided');
                    return;
                }
                if (cmd.type === 'push')
                    react_native_navigation_1.Navigation.push(id, cmd.layout);
                if (cmd.type === 'pop')
                    react_native_navigation_1.Navigation.pop(id, cmd.options);
                if (cmd.type === 'popTo')
                    react_native_navigation_1.Navigation.popTo(id);
                if (cmd.type === 'popToRoot')
                    react_native_navigation_1.Navigation.popToRoot(id);
                if (cmd.type === 'showModal')
                    react_native_navigation_1.Navigation.showModal(cmd.layout);
                if (cmd.type === 'dismissModal')
                    react_native_navigation_1.Navigation.dismissModal(id);
                if (cmd.type === 'dismissAllModals')
                    react_native_navigation_1.Navigation.dismissAllModals();
                if (cmd.type === 'setStackRoot') {
                    react_native_navigation_1.Navigation.setStackRoot(id, cmd.layout);
                }
                if (cmd.type === 'showOverlay') {
                    react_native_navigation_1.Navigation.showOverlay(cmd.layout);
                }
                if (cmd.type === 'dismissOverlay') {
                    react_native_navigation_1.Navigation.dismissOverlay(id);
                }
                if (cmd.type === 'mergeOptions') {
                    react_native_navigation_1.Navigation.mergeOptions(id, cmd.opts);
                }
            },
        });
    }
}
exports.runGlobal = runGlobal;
//# sourceMappingURL=global.js.map