"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const react_native_navigation_1 = require("react-native-navigation");
const run_1 = require("@cycle/run");
const makeComponent_1 = require("./makeComponent");
const global_1 = require("./global");
const symbols_1 = require("./symbols");
function run(screens, drivers, layout, defaultOpts) {
    const engine = run_1.setupReusable(drivers);
    for (const [id, main] of Object.entries(screens)) {
        react_native_navigation_1.Navigation.registerComponent(id, makeComponent_1.default(main, engine, id));
    }
    react_native_navigation_1.Navigation.events().registerAppLaunchedListener(() => {
        if (defaultOpts)
            react_native_navigation_1.Navigation.setDefaultOptions(defaultOpts);
        react_native_navigation_1.Navigation.setRoot({ root: layout });
        if (screens[symbols_1.GlobalScreen]) {
            global_1.runGlobal(screens[symbols_1.GlobalScreen], engine);
        }
    });
}
exports.run = run;
//# sourceMappingURL=run.js.map